function [ lat,lon,h ] = ECEF2LatLon( X,Y,Z,a,b )

e = sqrt((a^2-b^2)/a^2);
phi = 0;
N = 0;
cont = 1;

p = sqrt(X^2+Y^2);
phi_approx = atan((Z/p)*(1/(1-e^2)));

while cont==1
    N_approx = a^2/(sqrt((a^2)*(cos(phi_approx)^2)+(b^2)*(sin(phi_approx)^2)));
    h = (p/cos(phi_approx))-N_approx;
    
    tan_phi_improved = (Z/p)*(1/(1-(e^2)*(N_approx/(N_approx+h))));
    phi_improved = atan(tan_phi_improved);
    
    if abs(phi_improved - phi_approx) > 0.000000001
        phi_approx = phi_improved;
    else 
        phi = phi_improved;
        N = N_approx;
        cont = 0;
    end
end

h = (p/cos(phi))-N;
lat = rad2deg(phi);
tan_lambda = Y/X;
lon = rad2deg(atan(tan_lambda));

end