function [ estimated_coordinates, cofactor_estimated, std_weight_unit ] = conditional_adjustment( weight_condition,l )
%UNTITLED7 Summary of this function goes here
%   Detailed explanation goes here

%Vektsmatrise for observasjonene: weight_condition inneholder enten
%korrelasjonskoeffisientene eller kovariansmatrisa.
P = inv(weight_condition); 

%betingelsesligningene er:
%l1 + l4 + l6 - l3 = 0 (x1+x4+x6-x3=0, y1+y4+y6-y3=0, zi+....)
%l1 + l4 - l2 = 0
%l1 + l5 -l3 = 0

A = [-1 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 0 ; 0 -1 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 ; 0 0 -1 0 0 1 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 ;
      0 0 0 1 0 0 -1 0 0 0 0 0 0 0 0 1 0 0 0 0 0 ; 0 0 0 0 1 0 0 -1 0 0 0 0 0 0 0 0 1 0 0 0 0 ; 0 0 0 0 0 1 0 0 -1 0 0 0 0 0 0 0 0 1 0 0 0 ;
     -1 0 0 1 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 ; 0 -1 0 0 1 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 ; 0 0 -1 0 0 1 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 ];

[n_0,n] = size(A);

%konstantleddet
d = [0 ; 0 ; 0 ; 0 ; 0 ; 0 ; 0 ; 0 ; 0]; %summene i betingelsesligningene

f = d - A*l; %trekker fra summene gitt av betingelsesligningene (med basis i observasjonene (snittlengde p baselinjene))

%kofaktormatrise
Q = inv(P);

%kofaktormatrise til ekvivalente observasjoner
Q_e = A*Q*A';

P_e = inv(Q_e);

v = Q*A'*P_e*f;

l_hat = l + v;

Q_ll = Q - Q*A'*P_e*A*Q;

estimated_coordinates = l_hat;
cofactor_estimated = Q_ll;
std_weight_unit = sqrt((v'*P*v)/(n-n_0));

end

