%Skriptet konverterer fra UTM med ellipsoidiske hyder til ECEF-koordinater

a = 6378137;
b = 6.356752314245000e+06;

%%%%% For input fra konsoll %%%%%%%
% UTM_N = input('Skriv inn nord-verdien for punktet i UTM: ');
% UTM_E = input('Skriv inn st-verdien for punktet i UTM: ');
% h_ell = input('Skriv inn den ellipsoidiske hyden for punktet i UTM: ');
% [B,L] = calculate_UTM2LatLon(UTM_N, UTM_E);
% B = deg2rad(B);
% L = deg2rad(L);
% [X,Y,Z] = geod2ECEF(a,b,B,L,h_ell)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

UTM_N1 = 7032871.8061;
UTM_E1 = 570073.1872;
h_ell1 = 130.2434;

UTM_N2 = 7032874.7507;
UTM_E2 = 570079.2076;
h_ell2 = 130.2450;

UTM_N3 = 7032886.5256;
UTM_E3 = 570103.3508;
h_ell3 = 130.1909;

UTM_N4 = 7032889.1767;
UTM_E4 = 570108.8334;
h_ell4 = 130.1859;

[B1,L1] = calculate_UTM2LatLon(UTM_N1, UTM_E1);
[B2,L2] = calculate_UTM2LatLon(UTM_N2, UTM_E2);
[B3,L3] = calculate_UTM2LatLon(UTM_N3, UTM_E3);
[B4,L4] = calculate_UTM2LatLon(UTM_N4, UTM_E4);

B1 = deg2rad(B1);
L1 = deg2rad(L1);

B2 = deg2rad(B2);
L2 = deg2rad(L2);

B3 = deg2rad(B3);
L3 = deg2rad(L3);

B4 = deg2rad(B4);
L4 = deg2rad(L4);

[X1,Y1,Z1] = geod2ECEF(a,b,B1,L1,h_ell1);
[X2,Y2,Z2] = geod2ECEF(a,b,B2,L2,h_ell2);
[X3,Y3,Z3] = geod2ECEF(a,b,B3,L3,h_ell3);
[X4,Y4,Z4] = geod2ECEF(a,b,B4,L4,h_ell4);

baseline1 = [X2,Y2,Z2] - [X1,Y1,Z1];
baseline2 = [X3,Y3,Z3] - [X1,Y1,Z1];
baseline3 = [X4,Y4,Z4] - [X1,Y1,Z1];
baseline4 = [X3,Y3,Z3] - [X2,Y2,Z2];
baseline5 = [X4,Y4,Z4] - [X2,Y2,Z2];
baseline6 = [X4,Y4,Z4] - [X3,Y3,Z3];

length_baseline1 = sqrt(baseline1(1)^2+baseline1(2)^2+baseline1(3)^2);
length_baseline2 = sqrt(baseline2(1)^2+baseline2(2)^2+baseline2(3)^2);
length_baseline3 = sqrt(baseline3(1)^2+baseline3(2)^2+baseline3(3)^2);
length_baseline4 = sqrt(baseline4(1)^2+baseline4(2)^2+baseline4(3)^2);
length_baseline5 = sqrt(baseline5(1)^2+baseline5(2)^2+baseline5(3)^2);
length_baseline6 = sqrt(baseline6(1)^2+baseline6(2)^2+baseline6(3)^2);

%baselinjer direkte fra UTM:
m = skaleringsfaktorUTM(a,b,rad2deg((B1+B2+B3+B4)/4));

baseline1_UTM = [UTM_N2-UTM_N1, UTM_E2-UTM_E1, h_ell2-h_ell1];
baseline2_UTM = [UTM_N3-UTM_N1, UTM_E3-UTM_E1, h_ell3-h_ell1];
baseline3_UTM = [UTM_N4-UTM_N1, UTM_E4-UTM_E1, h_ell4-h_ell1];
baseline4_UTM = [UTM_N3-UTM_N2, UTM_E3-UTM_E2, h_ell3-h_ell2];
baseline5_UTM = [UTM_N4-UTM_N2, UTM_E4-UTM_E2, h_ell4-h_ell2];
baseline6_UTM = [UTM_N4-UTM_N3, UTM_E4-UTM_E3, h_ell4-h_ell3];

length_baseline1_UTM = sqrt(baseline1_UTM(1)^2+baseline1_UTM(2)^2+baseline1_UTM(3)^2)/m;
length_baseline2_UTM = sqrt(baseline2_UTM(1)^2+baseline2_UTM(2)^2+baseline2_UTM(3)^2)/m;
length_baseline3_UTM = sqrt(baseline3_UTM(1)^2+baseline3_UTM(2)^2+baseline3_UTM(3)^2)/m;
length_baseline4_UTM = sqrt(baseline4_UTM(1)^2+baseline4_UTM(2)^2+baseline4_UTM(3)^2)/m;
length_baseline5_UTM = sqrt(baseline5_UTM(1)^2+baseline5_UTM(2)^2+baseline5_UTM(3)^2)/m;
length_baseline6_UTM = sqrt(baseline6_UTM(1)^2+baseline6_UTM(2)^2+baseline6_UTM(3)^2)/m;